SystemOrganization addCategory: #'DAO-TP-Changes-AnnounceReader'!

Object subclass: #InterfazParaAnuncios
	instanceVariableNames: 'systemAnnouncer interfazDeEntradaDelSistemaDeCambios'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DAO-TP-Changes-AnnounceReader'!

!InterfazParaAnuncios class methodsFor: 'as yet unclassified' stamp: 'SebastianGarbi 10/19/2013 18:50'!
newWith: anAnnouncer and: unaInterfazDeEntradaDelSistemaDeCambios 
	^self new initializeWith: anAnnouncer and: unaInterfazDeEntradaDelSistemaDeCambios.! !

!InterfazParaAnuncios class methodsFor: 'as yet unclassified' stamp: 'SebaServer 12/4/2013 00:36'!
unsubscribeAll
(AnnouncementSubscription allInstances select: [ :a | a subscriber class = self ]) do: [ :aFuckingAnnouncement |
	 aFuckingAnnouncement announcer removeSubscription: aFuckingAnnouncement
].
^'yeah'.! !

!InterfazParaAnuncios methodsFor: 'auxiliar' stamp: 'SebastianGarbi 10/19/2013 23:19'!
classVarNamesOf: aClass 
	^aClass classVariablesString substrings asSet.! !

!InterfazParaAnuncios methodsFor: 'auxiliar' stamp: 'SebastianGarbi 9/30/2013 10:16'!
esDeClase: unaClase
	^ unaClase isKindOf: Metaclass! !

!InterfazParaAnuncios methodsFor: 'as yet unclassified' stamp: 'SebastianGarbi 9/30/2013 18:39'!
handleInstanceVars: agregados inClass: affectedClassName for: anInstanceVariableChange
	agregados
		do: [ :anInstanceVar | 
			interfazDeEntradaDelSistemaDeCambios
				handle: (anInstanceVariableChange onClass: affectedClassName instanceVarAffected: anInstanceVar) ]! !

!InterfazParaAnuncios methodsFor: 'initialize-release' stamp: 'SebastianGarbi 10/19/2013 19:23'!
initializeClassCategoryEvents
	systemAnnouncer
		on: CategoryRenamed
		do: [ :unEvento | 
			interfazDeEntradaDelSistemaDeCambios classCategoryRenamedFrom: unEvento oldCategoryName to: unEvento newCategoryName
		].
			
	systemAnnouncer
		on: CategoryAdded
		do: [ :unEvento |
			interfazDeEntradaDelSistemaDeCambios classCategoryCreated: unEvento categoryName
		].
		
	systemAnnouncer
		on: CategoryRemoved
		do: [ :unEvento |
			interfazDeEntradaDelSistemaDeCambios classCategoryRemoved: unEvento categoryName
		]! !

!InterfazParaAnuncios methodsFor: 'initialize-release' stamp: 'SebastianGarbi 10/19/2013 22:49'!
initializeClassEvents
	self initialize_ClassAdded.
	systemAnnouncer
		on: ClassRemoved
		do: [ :unEvento | interfazDeEntradaDelSistemaDeCambios classRemoved: unEvento classRemoved name fromCategory: unEvento categoryName ].
	systemAnnouncer
		on: ClassRecategorized
		do: [ :unEvento | 
			interfazDeEntradaDelSistemaDeCambios
				classRecategorized: unEvento classRecategorized name
				fromCategory: unEvento oldCategory
				toCategory: unEvento newCategory ].
	self initialize_ClassModifiedClassDefinition! !

!InterfazParaAnuncios methodsFor: 'initialize-release' stamp: 'SebastianGarbi 11/2/2013 15:23'!
initializeMethodEvents
	systemAnnouncer
		on: MethodAdded
		do: [ :unEvento | 
			(self esDeClase: unEvento methodClass)
				ifTrue: [ interfazDeEntradaDelSistemaDeCambios classMethod: unEvento selector createdOn: (unEvento methodClass allInstances at: 1) name inCategory: unEvento protocol withCode: unEvento methodAffected sourceCode]
				ifFalse: [ interfazDeEntradaDelSistemaDeCambios instanceMethod: unEvento selector createdOn: unEvento methodClass name inCategory: unEvento protocol withCode: unEvento methodAffected sourceCode].
		].

	systemAnnouncer
		on: MethodRemoved
		do: [ :unEvento | 
			(self esDeClase: unEvento methodClass)
				ifTrue: [ interfazDeEntradaDelSistemaDeCambios classMethod: unEvento selector removedFrom: (unEvento methodClass allInstances at: 1) name inCategory: unEvento protocol withCode: unEvento methodAffected sourceCode ]
				ifFalse: [ interfazDeEntradaDelSistemaDeCambios instanceMethod: unEvento selector removedFrom: unEvento methodClass name inCategory: unEvento protocol withCode: unEvento methodAffected sourceCode].
		].

	systemAnnouncer
		on: MethodRecategorized
		do: [ :unEvento | 
			(self esDeClase: unEvento methodClass)
				ifTrue: [  interfazDeEntradaDelSistemaDeCambios classMethod: unEvento selector onClass: (unEvento methodClass allInstances at: 1) name recategorizedFrom: unEvento oldProtocol to: unEvento newProtocol.]
				ifFalse: [ interfazDeEntradaDelSistemaDeCambios instanceMethod: unEvento selector onClass: unEvento methodClass name recategorizedFrom: unEvento oldProtocol to: unEvento newProtocol.].
		].
	
	systemAnnouncer
		on: MethodModified
		do: [ :unEvento | 
			(self esDeClase: unEvento methodClass)
				ifTrue: [
					interfazDeEntradaDelSistemaDeCambios classMethodChanged: unEvento selector onClass: (unEvento methodClass allInstances at: 1) name oldSourceCode: unEvento oldMethod sourceCode newSourceCode: unEvento newMethod sourceCode.
					unEvento oldProtocol ~= unEvento newProtocol ifTrue: [
						interfazDeEntradaDelSistemaDeCambios classMethod: unEvento selector onClass: (unEvento methodClass allInstances at: 1) name recategorizedFrom: unEvento oldProtocol to: unEvento newProtocol.
					].
				]
				ifFalse: [
					interfazDeEntradaDelSistemaDeCambios instanceMethodChanged: unEvento selector onClass: unEvento methodClass name oldSourceCode: unEvento oldMethod sourceCode newSourceCode: unEvento newMethod sourceCode.
					unEvento oldProtocol ~= unEvento newProtocol ifTrue: [
						interfazDeEntradaDelSistemaDeCambios instanceMethod: unEvento selector onClass: unEvento methodClass name recategorizedFrom: unEvento oldProtocol to: unEvento newProtocol.
					].
				].
		].
	systemAnnouncer
		on: ClassReorganized
		do: [ :unEvento | 
			(self esDeClase: unEvento classReorganized)
				ifTrue: [ interfazDeEntradaDelSistemaDeCambios classMethodCategoyReorganized: (unEvento classReorganized allInstances at: 1) name categories: unEvento classReorganized organization categories  ]
				ifFalse: [ interfazDeEntradaDelSistemaDeCambios instanceMethodCategoyReorganized: unEvento classReorganized name categories: unEvento classReorganized organization categories ].
		].! !

!InterfazParaAnuncios methodsFor: 'initialize-release' stamp: 'SebastianGarbi 9/30/2013 10:05'!
initializeWith: anAnnouncer and: unaInterfaceDeEntradaDelSistemaDeCambios
	systemAnnouncer := anAnnouncer.
	interfazDeEntradaDelSistemaDeCambios := unaInterfaceDeEntradaDelSistemaDeCambios.

	self initializeClassEvents.
	self initializeMethodEvents.
	self initializeClassCategoryEvents.
	
! !

!InterfazParaAnuncios methodsFor: 'initialize-release' stamp: 'SebastianGarbi 10/19/2013 22:49'!
initialize_ClassAdded
	| instVars classVars |
	systemAnnouncer
		on: ClassAdded
		do: [ :unEvento | 
			interfazDeEntradaDelSistemaDeCambios
				classCreated: unEvento classAdded name
				inCategory: unEvento classCategory
				superclass: unEvento classAdded superclass name.
			instVars := self instanceVarNamesOf: unEvento classAdded.
			instVars
				do: [ :anInstanceVarName | interfazDeEntradaDelSistemaDeCambios instanceVariableCreatedOn: unEvento classAdded name named: anInstanceVarName ].
			classVars := self classVarNamesOf: unEvento classAdded.
			classVars
				do: [ :aClassVarName | interfazDeEntradaDelSistemaDeCambios classVariableCreatedOn: unEvento classAdded name named: aClassVarName ] ]! !

!InterfazParaAnuncios methodsFor: 'initialize-release' stamp: 'Maxii 11/8/2013 12:23'!
initialize_ClassModifiedClassDefinition
	systemAnnouncer
		on: ClassModifiedClassDefinition
		do: [ :unEvento | 
			self registerSuperClassChangedChange: unEvento.
			self registerInstanceVariableChange: unEvento.
			self registerClassVariableChange: unEvento.
			self registerPoolDictionaryChange: unEvento.
"			self registerClassRecategoized: unEvento."
			]! !

!InterfazParaAnuncios methodsFor: 'auxiliar' stamp: 'SebastianGarbi 10/19/2013 23:19'!
instanceVarNamesOf: aClass 
	^aClass instanceVariablesString substrings asSet.! !

!InterfazParaAnuncios methodsFor: 'as yet unclassified' stamp: 'SebastianGarbi 10/19/2013 23:45'!
registerClassRecategoized: unEvento 
	| oldClassCategory newClassCategory  | 
	oldClassCategory := unEvento oldClassDefinition category.
	newClassCategory := unEvento newClassDefinition category.

	oldClassCategory ~= newClassCategory ifTrue: [ 
		interfazDeEntradaDelSistemaDeCambios
			classRecategorized: unEvento classAffected name
			fromCategory: oldClassCategory 
			toCategory: newClassCategory
	]! !

!InterfazParaAnuncios methodsFor: 'as yet unclassified' stamp: 'SebastianGarbi 10/19/2013 23:50'!
registerClassVariableChange: unEvento
	| affectedClassName newVars agregados oldVars removidos |
	affectedClassName := unEvento classAffected name.
	oldVars := (self classVarNamesOf: unEvento oldClassDefinition).
	newVars := (self classVarNamesOf: unEvento newClassDefinition).
	agregados := newVars copy
		removeAllFoundIn: oldVars;
		yourself.
	removidos := oldVars copy
		removeAllFoundIn: newVars;
		yourself.
		
	agregados do: [ :aVarName | 
		interfazDeEntradaDelSistemaDeCambios classVariableCreatedOn: affectedClassName named: aVarName.
	].

	removidos do: [ :aVarName | 
		interfazDeEntradaDelSistemaDeCambios classVariableRemovedFrom: affectedClassName named: aVarName.
	]

! !

!InterfazParaAnuncios methodsFor: 'as yet unclassified' stamp: 'SebastianGarbi 11/2/2013 18:22'!
registerInstanceVariableChange: unEvento
	| affectedClassName newVars agregados oldVars removidos esDeClase |
	esDeClase := self esDeClase: unEvento classAffected.
	oldVars := (self instanceVarNamesOf: unEvento oldClassDefinition).
	newVars := (self instanceVarNamesOf: unEvento newClassDefinition).
	agregados := newVars copy
		removeAllFoundIn: oldVars;
		yourself.
	removidos := oldVars copy
		removeAllFoundIn: newVars;
		yourself.
	esDeClase ifTrue: [ 	
		affectedClassName := unEvento classAffected allInstances first name.
		agregados do: [ :aVarName | 
			interfazDeEntradaDelSistemaDeCambios classInstanceVariableCreatedOn: affectedClassName named: aVarName.
		].
	
		removidos do: [ :aVarName | 
			interfazDeEntradaDelSistemaDeCambios classInstanceVariableRemovedFrom: affectedClassName named: aVarName.
		]
	]
	ifFalse:[
		affectedClassName := unEvento classAffected name.
		agregados do: [ :aVarName | 
			interfazDeEntradaDelSistemaDeCambios instanceVariableCreatedOn: affectedClassName named: aVarName.
		].
	
		removidos do: [ :aVarName | 
			interfazDeEntradaDelSistemaDeCambios instanceVariableRemovedFrom: affectedClassName named: aVarName.
		]
	]

! !

!InterfazParaAnuncios methodsFor: 'as yet unclassified' stamp: 'Maxii 11/9/2013 19:09'!
registerPoolDictionaryChange: unEvento 
	| oldPools newPools agregados removidos affectedClassName |
	
	affectedClassName := unEvento classAffected name.
	
	oldPools := unEvento oldClassDefinition sharedPools asSet.
	newPools := unEvento newClassDefinition sharedPools asSet.
	
	agregados := newPools copy
		removeAllFoundIn: oldPools;
		yourself.
	
	removidos := oldPools copy
		removeAllFoundIn:  newPools ;
		yourself.
	
	agregados do: [ :poolVars | 
		interfazDeEntradaDelSistemaDeCambios poolDictionaryCreatedOn: affectedClassName named: poolVars printString .
	].

	removidos do: [ :poolVars | 
		interfazDeEntradaDelSistemaDeCambios poolDictionaryRemovedFrom: affectedClassName named: poolVars printString.
	]
	
	! !

!InterfazParaAnuncios methodsFor: 'as yet unclassified' stamp: 'SebastianGarbi 10/19/2013 22:54'!
registerSuperClassChangedChange: unEvento
	| oldSuperclassName newSuperclassName |
	oldSuperclassName := unEvento oldClassDefinition superclass name.
	newSuperclassName := unEvento newClassDefinition superclass name.
	oldSuperclassName ~= newSuperclassName
		ifTrue: [ 
			interfazDeEntradaDelSistemaDeCambios superclassChangedOn: unEvento newClassDefinition name from: oldSuperclassName to: newSuperclassName.
"				handle:
					(SuperclassChangedChange
						newAffectedClassName: unEvento newClassDefinition name
						oldSuperclassName: unEvento oldClassDefinition superclass name
						newSupeclassName: unEvento newClassDefinition superclass name) "
		]! !
